#!/usr/bin/perl -w
require 'getsky.pl';
use Jcode;

# դʸ
sub getDateStr {
    my $daydelta = shift @_; #ˤȤλդȤΤ '-2' '+5'
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time() + (24*60*60)*$daydelta);
    $theday = sprintf("%d-%d-%d", $mon+1,$mday,$year+1900);
    return $theday;
}


my @days = ();
my @channel = ();

## CGI ǥ
##
my $buffer = "";
read(STDIN, $buffer, $ENV{CONTENT_LENGTH});
my $days_c = 0; #counter
my $channel_c = 0; #counter
my @pairs = split(/&/, $buffer);
foreach (@pairs){
    ($name, $val) = split(/=/, $_);
    if($name eq "day"){
        #+ס-פǥɤ
        $val =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C",hex($1))/eg;
        $days[$days_c] = $val;
        $days_c++;
    }elsif($name eq "channel"){
        $channel[$channel_c] = $val;
        $channel_c++;
    }
}

## û̼ɤ߹
##
open(DICT, "skyp.dic");
my %translate;
while(<DICT>){
    s/\#.*$//; ##װʹߤϥȤȤƺ
    /^(.*), *(.*)$/;
    $translate{$1} = $2;
}
close(DICT);




## HTML 
foreach my $daydelta (@days){
    foreach my $ch (@channel){
        getTimeTable($ch, $daydelta);
    }
}


### text
foreach my $daydelta (@days){
    foreach my $ch (@channel){
        $theday = getDateStr($daydelta);
        my $fname = "${ch}_${theday}.txt";

        ## ˤƥȥեʤ
        if(-e $fname){
            if((-s $fname) < 300){
                unlink $fname; #ե륵 ʤȤϺ
            }else{
                # print "$fname already exists\n";
                next; #դΥե褦Ȥ
            }
        }

## HTMLեɤ߹
        my $srcname = "${ch}_${theday}.html";
        open(READ, $srcname) || die "'$srcname' does not exist!";
        undef $/;
        my $sjis = <READ>;
        close(READ);
        ## ʸѴ (shift_jis to EUC-JP, ȾѤ)
        my $euc = Jcode->new($sjis,'sjis')->tr('--ڣ-ʡˡ','0-9A-Za-z#(),,!')->euc;
        my @file = split(/\n/, $euc);

## ȥȥ
##
        my $progtable = 0;
        my %title = ();
        my $newtime = 0; # 0..can get a title, 1..cannot get
        my @timetable = ();
        my $timetable_c = 0;
        my $timestr = ""; #ѿ

        foreach (@file){
            if($progtable == 1){
                if($newtime == 0 && / class="tx" /){
                    ($timestr) = m@</A>(.*)</FONT>@;
                    $timetable[$timetable_c] = $timestr;
                    $timetable_c++;
                    $newtime = 1;
                }
                if($newtime == 1 && / class="nm" /){
                    ($title{$timestr}) = m@<B>(.*)</B>@;
                    $newtime = 0;
                }
            }
            if($progtable == 0){
                if(/<!---ɽ---->/){
                    $progtable = 1;
                }
            }
        }

        open(WRITE, ">$fname");
        print WRITE "$ch - $theday\n\n";
        foreach my $times (@timetable){
            my $t = $title{$times};

# û̼ˤû
            foreach(keys(%translate)){
                $t =~ s/$_/$translate{$_}/;
            }

# ÿʬΥ
            $t =~ s/([^ ])\#/$1 \#/;
            $t =~ s/([1-9\.\,]*)/ #$1/;

# ɽ
            print WRITE sprintf("%s\t%-14s\t\n", $times, $t);
        }
        close(WRITE);
    }
}




## 󥯲ɽ
##
print qq|Content-Type: text/html\r
\r
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=euc-jp">
  <title>SkyPerfecTV</title>
</head>
<body>
<table>
<tr>
|;
foreach my $daydelta (@days){
    $theday = getDateStr($daydelta);
    print qq|
  <th>$theday
  </th>
|;
}
print qq|
</tr>
<tr>
|;

foreach my $daydelta (@days){
    $theday = getDateStr($daydelta);
    print qq|
  <td>
|;
    foreach my $ch (@channel){
        my $fname = "${ch}_${theday}.txt";
        print qq|  <a href="/home/i/local/cgi-bin/$fname">$ch</a><br>\n|;
    }
    print qq|
</td>
|;
}
print qq|
</tr>
</table>
</body></html>
|;        
